2015暑假多校联合---Mahjong tree(树上DP 、深搜)

题目链接

http://acm.split.hdu.edu.cn/showproblem.php?pid=5379

Problem Description
Little sun is an artist. Today he is playing mahjong alone. He suddenly feels that the tree in the yard doesn't look good. So he wants to decorate the tree.(The tree has n vertexs, indexed from 1 to n.)
Thought for a long time, finally he decides to use the mahjong to decorate the tree.
His mahjong is strange because all of the mahjong tiles had a distinct index.(Little sun has only n mahjong tiles, and the mahjong tiles indexed from 1 to n.)
He put the mahjong tiles on the vertexs of the tree.
As is known to all, little sun is an artist. So he want to decorate the tree as beautiful as possible.
His decoration rules are as follows:

(1)Place exact one mahjong tile on each vertex.
(2)The mahjong tiles' index must be continues which are placed on the son vertexs of a vertex.
(3)The mahjong tiles' index must be continues which are placed on the vertexs of any subtrees.

Now he want to know that he can obtain how many different beautiful mahjong tree using these rules, because of the answer can be very large, you need output the answer modulo 1e9 + 7.
 
Input
The first line of the input is a single integer T, indicates the number of test cases. 
For each test case, the first line contains an integers n. (1 <= n <= 100000)
And the next n - 1 lines, each line contains two integers ui and vi, which describes an edge of the tree, and vertex 1 is the root of the tree.
 
Output
For each test case, output one line. The output format is "Case #x: ans"(without quotes), x is the case number, starting from 1.
 
Sample Input
2
9
2 1
3 1
4 3
5 3
6 2
7 4
8 7
9 3
8
2 1
3 1
4 3
5 1
6 4
7 5
8 4
 
Sample Output
Case #1: 32
Case #2: 16
 
Author
UESTC
 
Source
 
Recommend
wange2014   |   We have carefully selected several similar problems for you:  5867 5866 5865 5864 5863 
 
题意:有一棵n个节点的树,有n-1条边,现在将1~n的数放到节点中,满足一下两个条件:
        1、每个节点的儿子节点上的数必须是连续的;
        2、每棵子树上的节点的数必须是连续的;
    求有多少种放这些数的方法?
 
思路:可以发现,对于某个节点,要求它的儿子之间连续,那么它的儿子节点中最多有两个儿子节点有孩子,其它叶子儿子结点之间可以随意排列,也就是排列;
 
代码如下:
#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <vector>
using namespace std;
const int N=100005;
const long long MOD=1e9+7;
vector<int>g[N];
long long A[N],res;

int dfs(int u,int f)
{
    int tot=1,nt=0;///包含根节点的所有节点,直接孩子节点,子树个数
    int n=g[u].size();
    int ns=n-1;
    if(u==1) ns++;
    for(int i=0;i<n;i++)
    {
        int v=g[u][i];
        if(v==f)  continue;///防止相邻的两个节点上下反复递归;
        int num=dfs(v,u);
        if(num>1)   nt++;
    }
    if(nt>2)///有大于两个子树不能使切割后连续
        return res =0;
    if(nt)///有一个或两个子树切割方法数都只有两个
        res=res*2%MOD;
    res=res*A[ns-nt]%MOD;///当有多个(非子树的)节点可自由排序;
    return ns+1;
}

int main()
{
    A[0]=1;
    for (int i=1;i<N;i++)
    A[i]=A[i-1]*i%MOD;

    int t,cas=1,n;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        for(int i=0;i<=n;i++)
        g[i].clear();
        for(int i=0;i<n-1;i++)
        {
            int a,b;
            scanf("%d%d",&a,&b);
            g[a].push_back(b);
            g[b].push_back(a);
        }
        if(n==1)
        {
            printf("Case #%d: 1
",cas++);
            continue;
        }
        res=1;
        dfs(1,0);
        printf("Case #%d: %lld
",cas++,res*2%MOD);//根节点左右两种切法
    }
    return 0;
}
 
原文地址:https://www.cnblogs.com/chen9510/p/5823513.html